## xrootd-4.12.0.tar.gz

=== CMakeLists.txt ===
#-------------------------------------------------------------------------------
# Project description
#-------------------------------------------------------------------------------
cmake_minimum_required( VERSION 2.6 )

IF(CMAKE_VERSION VERSION_GREATER "2.8.12")
   CMAKE_POLICY(SET CMP0022 OLD)
ENDIF()

project( XRootD )

set( CMAKE_MODULE_PATH
 ${PROJECT_SOURCE_DIR}/src
 ${PROJECT_SOURCE_DIR}/cmake )

if(NOT (CMAKE_VERSION VERSION_LESS "3.1"))
  cmake_policy(SET CMP0054 OLD)
endif()

if(CMAKE_VERSION VERSION_LESS "3.0")
  SET(CMAKE_DL_LIBS "-ldl")
endif()

include( XRootDUtils )
CheckBuildDirectory()

include( XRootDOSDefs )
include( XRootDDefaults )
include( XRootDSystemCheck )
include( XRootDFindLibs )

add_definitions( -DXRDPLUGIN_SOVERSION="${PLUGIN_VERSION}" )

#-------------------------------------------------------------------------------
# Generate the version header
#-------------------------------------------------------------------------------
execute_process(
  COMMAND ${CMAKE_SOURCE_DIR}/genversion.sh --print-only ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE XROOTD_VERSION
  OUTPUT_STRIP_TRAILING_WHITESPACE )

add_custom_target(
  XrdVersion.hh
  ${CMAKE_SOURCE_DIR}/genversion.sh ${CMAKE_SOURCE_DIR} )

# sigh, yet another ugly hack :(
macro( add_library _target )
  _add_library( ${_target} ${ARGN} )
  add_dependencies( ${_target} XrdVersion.hh )
endmacro()

macro( add_executable _target )
  _add_executable( ${_target} ${ARGN} )
  add_dependencies( ${_target} XrdVersion.hh )
endmacro()

#-------------------------------------------------------------------------------
# Checkout the vomsxrd submodule
#-------------------------------------------------------------------------------
find_package(Git QUIET)
if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
  option(GIT_SUBMODULES "Check submodules during build" ON)
  if(GIT_SUBMODULES)
    message(STATUS "Submodule update")
    execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive
                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                    RESULT_VARIABLE GIT_SUBMOD_RESULT)
    if(NOT GIT_SUBMOD_RESULT EQUAL "0")
      message(FATAL_ERROR "git submodule update --init failed with ${GIT_SUBMOD_RESULT}, please checkout submodules")
    endif()
  endif()
endif()

#-------------------------------------------------------------------------------
# Build in subdirectories
#-------------------------------------------------------------------------------
add_subdirectory( src )
add_subdirectory( bindings )

if( BUILD_TESTS )
  ENABLE_TESTING()
  add_subdirectory( tests )
endif()

include( XRootDSummary )


#-------------------------------------------------------------------------------
# Install XRootDConfig.cmake module
#-------------------------------------------------------------------------------

configure_file( "cmake/XRootDConfig.cmake.in" "cmake/XRootDConfig.cmake" @ONLY )

install(
  FILES ${CMAKE_BINARY_DIR}/cmake/XRootDConfig.cmake
  DESTINATION ${CMAKE_INSTALL_DATADIR}/xrootd/cmake )

#-------------------------------------------------------------------------------
# Configure an 'uninstall' target
#-------------------------------------------------------------------------------
CONFIGURE_FILE(
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== src/CMakeLists.txt ===

#-------------------------------------------------------------------------------
# Include the subcomponents
#-------------------------------------------------------------------------------
if( XRDCL_LIB_ONLY )
  set ( XRDCL_ONLY TRUE )
endif()

include( XrdUtils )
include( XrdApps )
include( XrdCrypto )
include( XrdSec )
include( XrdXml )
include( XrdHeaders )

if( BUILD_CRYPTO )
  include( XrdSecgsi )
endif()

if( BUILD_KRB5 )
  include( XrdSeckrb5 )
endif()

if( ENABLE_XRDCL )
  add_subdirectory( XrdCl )
endif()

if( XRDCLHTTP_SUBMODULE )
  add_subdirectory( XrdClHttp )
endif()


if( NOT XRDCL_ONLY )
  include( XrdClient )

  include( XrdServer )
  include( XrdDaemons )
  include( XrdFrm )
  include( XrdPosix )
  include( XrdFfs )
  include( XrdPlugins )
  include( XrdSsi )

  include( XrdFileCache )

  if( BUILD_HTTP )
    include( XrdHttp )
    include( XrdTpc )
  endif()

  if( BUILD_MACAROONS )
    include( XrdMacaroons )
  endif()

  if( XRDCEPH_SUBMODULE )
    add_subdirectory( XrdCeph )
  endif()

  option(VOMSXRD_SUBMODULE "Build xrdvoms plug-in." ON)
  if( VOMSXRD_SUBMODULE AND EXISTS "${PROJECT_SOURCE_DIR}/src/XrdXrootdVoms/CMakeLists.txt" )
    add_subdirectory( XrdXrootdVoms )
  endif()

endif()

#-------------------------------------------------------------------------------
# Install the utility scripts
#-------------------------------------------------------------------------------
if( NOT XRDCL_ONLY )
install(
  FILES
  ${CMAKE_SOURCE_DIR}/utils/XrdCmsNotify.pm
  ${CMAKE_SOURCE_DIR}/utils/netchk
  ${CMAKE_SOURCE_DIR}/utils/XrdOlbMonPerf
  ${CMAKE_SOURCE_DIR}/utils/cms_monPerf
  DESTINATION ${CMAKE_INSTALL_DATADIR}/xrootd/utils
  PERMISSIONS
  OWNER_EXECUTE OWNER_WRITE OWNER_READ
  GROUP_EXECUTE GROUP_READ
  WORLD_EXECUTE WORLD_READ )
endif()

if( NOT XRDCL_LIB_ONLY )
#-------------------------------------------------------------------------------
# Install xrootd-config
#-------------------------------------------------------------------------------
install(
  CODE "
    EXECUTE_PROCESS(
      COMMAND cat ${CMAKE_SOURCE_DIR}/utils/xrootd-config
      COMMAND sed -e \"s/__VERSION__/${XROOTD_VERSION}/\"
      COMMAND sed -e \"s|__INCLUDEDIR__|${CMAKE_INSTALL_INCLUDEDIR}|\"
      COMMAND sed -e \"s/__PLUGIN_VERSION__/${PLUGIN_VERSION}/\"
      COMMAND sed -e \"s|__PREFIX__|${CMAKE_INSTALL_PREFIX}|\"
      OUTPUT_FILE \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/xrootd-config )
    EXECUTE_PROCESS(
      COMMAND chmod 755 \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/xrootd-config )"
)

#-------------------------------------------------------------------------------
# Post process man pages
#-------------------------------------------------------------------------------
install(
  CODE "
    FILE(GLOB MANPAGES
      \"\$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_MANDIR}/man[1,8]/*.[1,8]\" )
    FOREACH(MANPAGE \${MANPAGES})
      MESSAGE( \"-- Processing: \" \${MANPAGE} )
      EXECUTE_PROCESS(
        COMMAND cat \${MANPAGE}
        COMMAND sed  -e \"s/__VERSION__/${XROOTD_VERSION}/\"
        OUTPUT_FILE \${MANPAGE}.new )
      EXECUTE_PROCESS(
        COMMAND mv -f \${MANPAGE}.new \${MANPAGE} )
    ENDFOREACH()"
)
endif()

=== bindings/python/CMakeLists.txt ===

set(SETUP_PY_IN    "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in")
set(SETUP_PY       "${CMAKE_CURRENT_BINARY_DIR}/setup.py")
set(DEPS           "${CMAKE_CURRENT_SOURCE_DIR}/libs/__init__.py")
set(OUTPUT         "${CMAKE_CURRENT_BINARY_DIR}/python_bindings")
set(XRD_SRCINCDIR  "${CMAKE_SOURCE_DIR}/src")
set(XRD_BININCDIR  "${CMAKE_BINARY_DIR}/src")
set(XRDCL_LIBDIR   "${CMAKE_BINARY_DIR}/src/XrdCl")
set(XRD_LIBDIR     "${CMAKE_BINARY_DIR}/src")
set(XRDCL_INSTALL  "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

if( PYPI_BUILD )
  set(XRDCL_RPATH  "$ORIGIN/${CMAKE_INSTALL_LIBDIR}")
else()
  set(XRDCL_RPATH  "$ORIGIN/../../..")
endif()

if( "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" )
  if( CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.7 )
    message( "clang 3.5" )
    set( CLANG_PROHIBITED ", '-Wp,-D_FORTIFY_SOURCE=2', '-fstack-protector-strong'" )
  endif()
endif()

configure_file(${SETUP_PY_IN} ${SETUP_PY})

add_custom_command(OUTPUT ${OUTPUT}
                   COMMAND ${PYTHON_EXECUTABLE} ${SETUP_PY} build
                   DEPENDS ${DEPS})

add_custom_target(python_target ALL DEPENDS ${OUTPUT} XrdCl)

# Get the distribution name on Debian families
execute_process( COMMAND grep -i ^NAME=\" /etc/os-release
                 OUTPUT_VARIABLE DEB_DISTRO )
STRING(REGEX REPLACE "^NAME=\"" "" DEB_DISTRO "${DEB_DISTRO}")
STRING(REGEX REPLACE "\".*"     "" DEB_DISTRO "${DEB_DISTRO}")

if( DEB_DISTRO STREQUAL "Debian" OR DEB_DISTRO STREQUAL "Ubuntu" )
  set(PYTHON_LAYOUT  "unix" CACHE STRING "Python installation layout (deb or unix)")
  set(DEB_INSTALL_ARGS "--install-layout ${PYTHON_LAYOUT}")
endif()

install(
  CODE
  "EXECUTE_PROCESS(
    COMMAND ${PYTHON_EXECUTABLE} ${SETUP_PY} install --prefix \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX} ${DEB_INSTALL_ARGS} --record PYTHON_INSTALLED)" )

=== tests/XrdClTests/CMakeLists.txt ===

include( XRootDCommon )
include_directories( ${CPPUNIT_INCLUDE_DIRS} ../common)

set( LIB_XRD_CL_TEST_MONITOR XrdClTestMonitor-${PLUGIN_VERSION} )


if( XrdClPipelines )
  set( OperationsWorkflowTest OperationsWorkflowTest.cc )
endif()

add_library(
  XrdClTests MODULE
  UtilsTest.cc
  SocketTest.cc
  PollerTest.cc
  PostMasterTest.cc
  FileSystemTest.cc
  FileTest.cc
  FileCopyTest.cc
  ThreadingTest.cc
  IdentityPlugIn.cc
  LocalFileHandlerTest.cc
  
  ${OperationsWorkflowTest}
)

target_link_libraries(
  XrdClTests
  XrdClTestsHelper
  pthread
  ${CPPUNIT_LIBRARIES}
  ${ZLIB_LIBRARY}
  XrdCl )

add_library(
  ${LIB_XRD_CL_TEST_MONITOR} MODULE
  MonitorTestLib.cc
)

target_link_libraries(
  ${LIB_XRD_CL_TEST_MONITOR}
  XrdClTestsHelper
  XrdCl )

#-------------------------------------------------------------------------------
# Install
#-------------------------------------------------------------------------------
install(
  TARGETS XrdClTests ${LIB_XRD_CL_TEST_MONITOR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} )

=== packaging/debian/control ===
Source: xrootd
Maintainer: Jozsef Makai <jozsef.makai@cern.ch>
Section: net
Priority: optional
Standards-Version: 3.9.3
Build-Depends: debhelper (>= 9), cmake (>=3.3.0), zlib1g-dev, libfuse-dev, python3-dev, libssl-dev, libxml2-dev, ncurses-dev, libkrb5-dev, libreadline-dev, libsystemd-dev, selinux-policy-dev, libcurl4-openssl-dev, systemd, uuid-dev, dh-python, voms-dev
Homepage: https://github.com/xrootd/xrootd
Vcs-Git: https://github.com/xrootd/xrootd.git
Vcs-Browser: https://github.com/xrootd/xrootd

#------------------------------------------------------------------------------
# XRootD libraries (compatibility)
#------------------------------------------------------------------------------
Package: xrootd-libs
Architecture: any
Section: libs
Depends: libxrdapputils1        (=${binary:Version}),
         libxrdcrypto1          (=${binary:Version}),
         libxrdcryptolite1      (=${binary:Version}),
	     libxrdutils2           (=${binary:Version}),
 		 libxrdxml2             (=${binary:Version}),
		 xrootd-plugins         (=${binary:Version})
Conflicts: xrootd-libs          (<<${binary:Version})
Description: This package contains libraries used by the xrootd servers and 
             clients.
             .
             This is a transitional dummy package which can be removed 
             afterinstallation of dependencies. 

#------------------------------------------------------------------------------
# XRootD plug-ins
#------------------------------------------------------------------------------
Package: xrootd-plugins
Architecture: any
Section: net
Depends: ${shlibs:Depends}
Conflicts: xrootd-plugins  (<<${binary:Version})
Description: This package contains additional plugins used by both client and
             server. 

#------------------------------------------------------------------------------
# XRootD development files (compatibility)
#------------------------------------------------------------------------------
Package: xrootd-devel
Architecture: any
Section: libdevel
Depends: libxrootd-dev  (=${binary:Version})
Conflicts: xrootd-devel (<<${binary:Version})
Description: This package contains header files and development libraries for
             xrootd development.
             .
             This is a transitional dummy package which can be removed after
             installation of dependencies 

#------------------------------------------------------------------------------
# XRootD development files
#------------------------------------------------------------------------------
Package: libxrootd-dev
Architecture: any
Section: libdevel
Depends: libxrdapputils1    (=${binary:Version}),
         libxrdcrypto1      (=${binary:Version}),
         libxrdcryptolite1  (=${binary:Version}),
	     libxrdutils2       (=${binary:Version}),
 		 libxrdxml2         (=${binary:Version}),
Conflicts: xrootd-devel     (<<${binary:Version})
Description: This package contains header files and development libraries for 
             xrootd development.

#------------------------------------------------------------------------------
# XRootD client libraries (compatibility)
#------------------------------------------------------------------------------
Package: xrootd-client-libs
Architecture: any
Depends: libxrdcl2              (=${binary:Version}),
         libxrdffs2             (=${binary:Version}),
         libxrdposix2           (=${binary:Version}),
         xrootd-client-plugins  (=${binary:Version}),
         xrootd-libs            (=${binary:Version})
Conflicts: xrootd-client-libs   (<<${binary:Version})
Description: This package contains libraries used by xrootd clients.
             .
             This is a transitional dummy package which can be removed after
             installation of dependencies 

#------------------------------------------------------------------------------
# XRootD client plug-ins
#------------------------------------------------------------------------------
Package: xrootd-client-plugins
Architecture: any
Section: net
Depends: ${shlibs:Depends}
Conflicts: xrootd-client-plugins  (<<${binary:Version})
Description: This package contains additional plugins used by the client. 

#------------------------------------------------------------------------------
# XRootD client development files (compatibility)
#------------------------------------------------------------------------------
Package: xrootd-client-devel
Architecture: any
Section: libdevel
Depends: libxrootd-client-dev (=${binary:Version})
Conflicts: xrootd-client-devel   (<<${binary:Version})
Description: This package contains header files and development libraries for 
             xrootd client development.
             .
             This is a transitional dummy package which can be removed after
             installation of dependencies 

#------------------------------------------------------------------------------
# XRootD client development files
#------------------------------------------------------------------------------
Package: libxrootd-client-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, 
         libxrootd-dev (=${binary:Version}),
         libxrdcl2     (=${binary:Version}),
         libxrdffs2    (=${binary:Version}),
         libxrdposix2  (=${binary:Version})
Conflicts: xrootd-client-devel (<<${binary:Version})
Description: This package contains header files and development libraries for 
             xrootd client development.

#------------------------------------------------------------------------------
# XRootD client (compatibility)
#------------------------------------------------------------------------------ 
Package: xrootd-client
Architecture: any
Section: net
Depends: xrootd-clients  (=${binary:Version})
Conflicts: xrootd-client (<<${binary:Version})
Description: This package contains the command line tools used to communicate 
             with xrootd servers.
             .
             This is a transitional dummy package which can be removed after
             installation of dependencies 
 
#------------------------------------------------------------------------------
# XRootD client
#------------------------------------------------------------------------------ 
Package: xrootd-clients
Architecture: any
Section: net
Depends: ${shlibs:Depends}, 
         xrootd-client-libs  (=${binary:Version})
Conflicts: xrootd-clients (<<${binary:Version})
Description: This package contains the command line tools used to communicate
             with xrootd servers.

#------------------------------------------------------------------------------
# XRootD server
#------------------------------------------------------------------------------ 
Package: xrootd-server
Architecture: any
Section: net
Depends: ${shlibs:Depends}, 
         xrootd-server-libs     (=${binary:Version})
Conflicts: xrootd-server        (<<${binary:Version})
Description: This package contains the server applications and associated 
             utilities.

#------------------------------------------------------------------------------
# XRootD private development files (compatibility)
#------------------------------------------------------------------------------ 
Package: xrootd-private-devel
Architecture: any
Section: libdevel
Depends: libxrootd-private-dev   (=${binary:Version})
Conflicts: xrootd-private-devel  (<<${binary:Version})
Description: This package contains some private xrootd headers. The use of these 
             headers is strongly discouraged. Backward compatibility between 
             versions is not guaranteed for these headers.
             .
             This is a transitional dummy package which can be removed after
             installation of dependencies 

#------------------------------------------------------------------------------
# XRootD private development files
#------------------------------------------------------------------------------
Package: libxrootd-private-dev
Architecture: any
Section: libdevel
Depends: libxrootd-server-dev  (=${binary:Version}),
Conflicts: libxrootd-private-dev (<<${binary:Version})
Description: This package contains some private XRootd headers. The use of 
             these headers is strongly discouraged. Backward compatibility 
             between versions is not guaranteed for these headers.

#------------------------------------------------------------------------------
# XRootD server libs (compatibility)
#------------------------------------------------------------------------------
Package: xrootd-server-libs
Architecture: any
Section: libs
Depends: libxrdhttputils1       (=${binary:Version}),
	     libxrdserver2          (=${binary:Version}),
	     libxrdssilib1          (=${binary:Version}),
	     libxrdssishmap1        (=${binary:Version}),
	     xrootd-client-libs     (=${binary:Version}),
	     xrootd-server-plugins  (=${binary:Version}) 
Conflicts: xrootd-server-libs   (<<${binary:Version})
Description: This package contains libraries used by xrootd servers.
             .
             This is a transitional dummy package which can be removed after
             installation of dependencies 

#------------------------------------------------------------------------------
# XRootD server development files (compatibility)
#------------------------------------------------------------------------------
Package: xrootd-server-devel
Architecture: any
Section: libdevel
Depends: libxrootd-server-dev   (=${binary:Version})
Conflicts: xrootd-server-devel  (<<${binary:Version})
Description: This package contains header files and development libraries for
             xrootd server development.
             .
             This is a transitional dummy package which can be removed after
             installation of dependencies 

#------------------------------------------------------------------------------
# XRootD server development files
#------------------------------------------------------------------------------
Package: libxrootd-server-dev
Architecture: any
Section: libdevel
Depends: libxrdhttputils1        (=${binary:Version}),
	     libxrdserver2           (=${binary:Version}),
	     libxrdssilib1           (=${binary:Version}),
	     libxrdssishmap1         (=${binary:Version}),
	     libxrootd-client-dev    (=${binary:Version})
Conflicts: libxrootd-server-dev  (<<${binary:Version})
Description: High performance, scalable fault tolerant data repositories.
 This package contains header files and development libraries for
 xrootd server development.

#------------------------------------------------------------------------------
# XRootD server development files
#------------------------------------------------------------------------------
Package: xrootd-fuse
Architecture: any
Section: net
Depends: ${shlibs:Depends}, 
         libfuse-dev,
         xrootd-client-libs  (=${binary:Version}),
Conflicts: xrootd-fuse       (<<${binary:Version})
Description: This package contains the FUSE (file system in user space) 
             xrootd mount tool.

#------------------------------------------------------------------------------
# XRootD server plug-ins
#------------------------------------------------------------------------------
Package: xrootd-server-plugins
Architecture: any
Section: net
Depends: ${shlibs:Depends}
Description: This package contains additional plug-in libraries used by an 
             XRootd server. 

#------------------------------------------------------------------------------
# XRootD libxrdapputils1 (xroottd-libs)
#------------------------------------------------------------------------------
Package: libxrdapputils1
Architecture: any
Section: libs
Depends: ${shlibs:Depends}
Conflicts: libxrdapputils1 (<<${binary:Version})
Description: Library of utilities for applications.

#------------------------------------------------------------------------------
# XRootD libxrdcl2 (xrootd-client-libs)
